Imports Inventor
Imports System.Runtime.InteropServices
Imports Microsoft.Win32
Imports System.Windows.Forms
Imports System.Drawing
Imports System.Drawing.Imaging
Imports System.Drawing.Printing
Imports System.Drawing.Drawing2D

Namespace VBNet_Inventor_DrawingTool
    <ProgIdAttribute("VBNet_Inventor_DrawingTool.StandardAddInServer"), _
    GuidAttribute("fd342c3f-1727-4ce7-b269-0a8554250b5e")> _
    Public Class StandardAddInServer
        Implements Inventor.ApplicationAddInServer

        ' Inventor application object.
        Private m_inventorApplication As Inventor.Application
        Private WithEvents oUserInput As UserInputEvents

        'Variables for 
        Private WithEvents oCMButtonDef As ButtonDefinition
        Private oMyCommandBar As CommandBar

        Private m_ClientId As String
        Private m_ActiveX As Clipboard_Palette
        Private oPane As BrowserPane

        'Screenshot
        Private WithEvents oSSButtonDef As ButtonDefinition
        Private WithEvents m_InteractionEvents As InteractionEvents
        Private WithEvents m_MouseEvents As MouseEvents
        Private m_flagMouseDown As Boolean
        Private m_MouseStartPt As Inventor.Point2d
        Private m_StartModelPt As Inventor.Point


        Dim isRunningScreenshot As Boolean


#Region "ApplicationAddInServer Members"

        Public Sub Activate(ByVal addInSiteObject As Inventor.ApplicationAddInSite, ByVal firstTime As Boolean) Implements Inventor.ApplicationAddInServer.Activate

            ' This method is called by Inventor when it loads the AddIn.
            ' The AddInSiteObject provides access to the Inventor Application object.
            ' The FirstTime flag indicates if the AddIn is loaded for the first time.

            ' Initialize AddIn members.
            m_inventorApplication = addInSiteObject.Application

            ' TODO:  Add ApplicationAddInServer.Activate implementation.
            ' e.g. event initialization, command creation etc.

            m_ClientId = "{fd342c3f-1727-4ce7-b269-0a8554250b5e}"

            Dim largeIconSize As Integer
            If m_inventorApplication.UserInterfaceManager.InterfaceStyle = InterfaceStyleEnum.kRibbonInterface Then
                largeIconSize = 32
            Else
                largeIconSize = 24
            End If

            Dim controlDefs As ControlDefinitions = m_inventorApplication.CommandManager.ControlDefinitions
            Dim smallPicture1 As stdole.IPictureDisp = Microsoft.VisualBasic.Compatibility.VB6.IconToIPicture(New System.Drawing.Icon(My.Resources.CMButton, 16, 16))
            Dim largePicture1 As stdole.IPictureDisp = Microsoft.VisualBasic.Compatibility.VB6.IconToIPicture(New System.Drawing.Icon(My.Resources.CMButton, largeIconSize, largeIconSize))

            oCMButtonDef = controlDefs.AddButtonDefinition("ClipboardManager", "VBNet_Inventor_DrawingTool:CMDef", CommandTypesEnum.kNonShapeEditCmdType, m_ClientId, , , smallPicture1, largePicture1)
            oSSButtonDef = controlDefs.AddButtonDefinition("Screenshot", "VBNet_Inventor_DrawingTool:SSDef", CommandTypesEnum.kNonShapeEditCmdType, m_ClientId, , , smallPicture1, largePicture1)

            Try
                oMyCommandBar = m_inventorApplication.UserInterfaceManager.CommandBars("VBNet_Inventor_DrawingTool:commanBar")
            Catch ex As Exception
                oMyCommandBar = m_inventorApplication.UserInterfaceManager.CommandBars.Add("VBNet_Inventor_DrawingTool", "VBNet_Inventor_DrawingTool:commanBar", CommandBarTypeEnum.kRegularCommandBar, m_ClientId)
            End Try

            oMyCommandBar.Controls.AddButton(oCMButtonDef)
            oMyCommandBar.Controls.AddButton(oSSButtonDef)
            oMyCommandBar.Visible = True


        End Sub

        Public Sub Deactivate() Implements Inventor.ApplicationAddInServer.Deactivate

            ' This method is called by Inventor when the AddIn is unloaded.
            ' The AddIn will be unloaded either manually by the user or
            ' when the Inventor session is terminated.

            ' TODO:  Add ApplicationAddInServer.Deactivate implementation

            ' Release objects.
            Marshal.ReleaseComObject(m_inventorApplication)
            m_inventorApplication = Nothing

            System.GC.WaitForPendingFinalizers()
            System.GC.Collect()

        End Sub

        Public ReadOnly Property Automation() As Object Implements Inventor.ApplicationAddInServer.Automation

            ' This property is provided to allow the AddIn to expose an API 
            ' of its own to other programs. Typically, this  would be done by
            ' implementing the AddIn's API interface in a class and returning 
            ' that class object through this property.

            Get
                Return Nothing
            End Get

        End Property

        Public Sub ExecuteCommand(ByVal commandID As Integer) Implements Inventor.ApplicationAddInServer.ExecuteCommand

            ' Note:this method is now obsolete, you should use the 
            ' ControlDefinition functionality for implementing commands.

        End Sub

#End Region

#Region "COM Registration"

        ' Registers this class as an AddIn for Inventor.
        ' This function is called when the assembly is registered for COM.
        <ComRegisterFunctionAttribute()> _
        Public Shared Sub Register(ByVal t As Type)

            Dim clssRoot As RegistryKey = Registry.ClassesRoot
            Dim clsid As RegistryKey = Nothing
            Dim subKey As RegistryKey = Nothing

            Try
                clsid = clssRoot.CreateSubKey("CLSID\" + AddInGuid(t))
                clsid.SetValue(Nothing, "VBNet_Inventor_DrawingTool")
                subKey = clsid.CreateSubKey("Implemented Categories\{39AD2B5C-7A29-11D6-8E0A-0010B541CAA8}")
                subKey.Close()

                subKey = clsid.CreateSubKey("Settings")
                subKey.SetValue("AddInType", "Standard")
                subKey.SetValue("LoadOnStartUp", "1")

                'subKey.SetValue("SupportedSoftwareVersionLessThan", "")
                subKey.SetValue("SupportedSoftwareVersionGreaterThan", "13..")
                'subKey.SetValue("SupportedSoftwareVersionEqualTo", "")
                'subKey.SetValue("SupportedSoftwareVersionNotEqualTo", "")
                'subKey.SetValue("Hidden", "0")
                'subKey.SetValue("UserUnloadable", "1")
                subKey.SetValue("Version", 0)
                subKey.Close()

                subKey = clsid.CreateSubKey("Description")
                subKey.SetValue(Nothing, "VBNet_Inventor_DrawingTool")

            Catch ex As Exception
                System.Diagnostics.Trace.Assert(False)
            Finally
                If Not subKey Is Nothing Then subKey.Close()
                If Not clsid Is Nothing Then clsid.Close()
                If Not clssRoot Is Nothing Then clssRoot.Close()
            End Try

        End Sub

        ' Unregisters this class as an AddIn for Inventor.
        ' This function is called when the assembly is unregistered.
        <ComUnregisterFunctionAttribute()> _
        Public Shared Sub Unregister(ByVal t As Type)

            Dim clssRoot As RegistryKey = Registry.ClassesRoot
            Dim clsid As RegistryKey = Nothing

            Try
                clssRoot = Microsoft.Win32.Registry.ClassesRoot
                clsid = clssRoot.OpenSubKey("CLSID\" + AddInGuid(t), True)
                clsid.SetValue(Nothing, "")
                clsid.DeleteSubKeyTree("Implemented Categories\{39AD2B5C-7A29-11D6-8E0A-0010B541CAA8}")
                clsid.DeleteSubKeyTree("Settings")
                clsid.DeleteSubKeyTree("Description")
            Catch
            Finally
                If Not clsid Is Nothing Then clsid.Close()
                If Not clssRoot Is Nothing Then clssRoot.Close()
            End Try

        End Sub

        ' This property uses reflection to get the value for the GuidAttribute attached to the class.
        Public Shared ReadOnly Property AddInGuid(ByVal t As Type) As String
            Get
                Dim guid As String = ""
                Try
                    Dim customAttributes() As Object = t.GetCustomAttributes(GetType(GuidAttribute), False)
                    Dim guidAttribute As GuidAttribute = CType(customAttributes(0), GuidAttribute)
                    guid = "{" + guidAttribute.Value.ToString() + "}"
                Finally
                    AddInGuid = guid
                End Try
            End Get
        End Property

#End Region

        Private Sub oCMButtonDef_OnExecute(ByVal Context As Inventor.NameValueMap) Handles oCMButtonDef.OnExecute
            'get active document
            Dim oDoc As Document
            oDoc = m_inventorApplication.ActiveDocument

            If oDoc Is Nothing Then
                MsgBox("a document must be activated!")
                Return
            End If

            'get the BrowserPanes
            Dim oPanes As BrowserPanes
            oPanes = oDoc.BrowserPanes

            'add the BrowserPane with the control
            Try
                oPane = oPanes("VBNet_Inventor_DrawingTool.Clipboard_Palette")
            Catch ex As Exception
                Try
                    oPane = oPanes.Add("ClipboardManager", "VBNet_Inventor_DrawingTool.Clipboard_Palette")
                Catch ex1 As Exception
                    MsgBox(ex1.ToString())
                End Try

            End Try

            m_ActiveX = oPane.Control
            m_ActiveX.setInvApp(m_inventorApplication)

            If oCMButtonDef.Pressed = True Then
                oPane.Delete()
                oCMButtonDef.Pressed = False
            Else
                oPane.Activate()
                oCMButtonDef.Pressed = True
            End If

            oUserInput = m_inventorApplication.CommandManager.UserInputEvents
        End Sub


        Private Sub oUserInput_OnStartCommand(ByVal CommandID As Inventor.CommandIDEnum) Handles oUserInput.OnStartCommand

        End Sub

        Private Sub oSSButtonDef_OnExecute(ByVal Context As Inventor.NameValueMap) Handles oSSButtonDef.OnExecute
            If m_InteractionEvents Is Nothing Then
                m_InteractionEvents = m_inventorApplication.CommandManager.CreateInteractionEvents()
            Else
                m_InteractionEvents.Stop()
            End If

            m_InteractionEvents.InteractionDisabled = False

            If m_MouseEvents Is Nothing Then
                m_MouseEvents = m_InteractionEvents.MouseEvents
                m_MouseEvents.MouseMoveEnabled = True
            End If

            m_InteractionEvents.Name = "MyScreenshot"

            m_MouseStartPt = m_inventorApplication.TransientGeometry.CreatePoint2d(0, 0)

            m_flagMouseDown = False
            m_InteractionEvents.Start()

        End Sub

        Private Sub m_MouseEvents_OnMouseDown(ByVal Button As Inventor.MouseButtonEnum, ByVal ShiftKeys As Inventor.ShiftStateEnum, ByVal ModelPosition As Inventor.Point, ByVal ViewPosition As Inventor.Point2d, ByVal View As Inventor.View) Handles m_MouseEvents.OnMouseDown

            If m_InteractionEvents.Name = "MyScreenshot" Then
                m_MouseStartPt = ViewPosition
                m_StartModelPt = ModelPosition
                m_flagMouseDown = True
            End If

        End Sub

        Private Sub m_MouseEvents_OnMouseMove(ByVal Button As Inventor.MouseButtonEnum, ByVal ShiftKeys As Inventor.ShiftStateEnum, ByVal ModelPosition As Inventor.Point, ByVal ViewPosition As Inventor.Point2d, ByVal View As Inventor.View) Handles m_MouseEvents.OnMouseMove
            If m_InteractionEvents.Name = "MyScreenshot" And m_flagMouseDown = True Then

                Dim assDoc As DrawingDocument
                assDoc = m_inventorApplication.ActiveDocument

                m_InteractionEvents.InteractionGraphics.PreviewClientGraphics.Delete()

                Dim oGiNode As GraphicsNode
                oGiNode = m_InteractionEvents.InteractionGraphics.PreviewClientGraphics.AddNode(1)

                Dim oCoordSet As GraphicsCoordinateSet
                oCoordSet = m_InteractionEvents.InteractionGraphics.GraphicsDataSets.CreateCoordinateSet(1)

                Dim P1 As Inventor.Point
                Dim P2 As Inventor.Point
                Dim P3 As Inventor.Point
                Dim P4 As Inventor.Point

                P1 = m_inventorApplication.TransientGeometry.CreatePoint(m_StartModelPt.X, m_StartModelPt.Y, 0)
                P2 = m_inventorApplication.TransientGeometry.CreatePoint(ModelPosition.X, m_StartModelPt.Y, 0)
                P3 = m_inventorApplication.TransientGeometry.CreatePoint(ModelPosition.X, ModelPosition.Y, 0)
                P4 = m_inventorApplication.TransientGeometry.CreatePoint(m_StartModelPt.X, ModelPosition.Y, 0)

                Dim oColorSet As GraphicsColorSet
                oColorSet = m_InteractionEvents.InteractionGraphics.GraphicsDataSets.CreateColorSet(1)

                ' Add a single color to the set that is red.
                Call oColorSet.Add(1, 255, 0, 0)

                'Call oCoordSet.PutCoordinates(oPointCoords)
                oCoordSet.Add(1, P1)
                oCoordSet.Add(2, P2)
                oCoordSet.Add(3, P3)
                oCoordSet.Add(4, P4)
                oCoordSet.Add(5, P1)

                Dim oGiLineStripG As LineStripGraphics
                oGiLineStripG = oGiNode.AddLineStripGraphics()

                oGiLineStripG.CoordinateSet = oCoordSet
                oGiLineStripG.ColorSet = oColorSet

                m_inventorApplication.ActiveView.Update()
            End If
        End Sub

        Private Sub m_MouseEvents_OnMouseUp(ByVal Button As Inventor.MouseButtonEnum, ByVal ShiftKeys As Inventor.ShiftStateEnum, ByVal ModelPosition As Inventor.Point, ByVal ViewPosition As Inventor.Point2d, ByVal View As Inventor.View) Handles m_MouseEvents.OnMouseUp

            If m_InteractionEvents.Name = "MyScreenshot" Then

                m_InteractionEvents.InteractionGraphics.PreviewClientGraphics.Delete()
                m_inventorApplication.ActiveView.Update()

                m_flagMouseDown = False
                m_InteractionEvents.Stop()
                m_MouseEvents = Nothing
                m_InteractionEvents = Nothing
 
                Dim oSize As Size
                oSize = New Size(Math.Abs(ViewPosition.X - m_MouseStartPt.X), Math.Abs(ViewPosition.Y - m_MouseStartPt.Y))

                Dim oCornerPt As Point2d = m_inventorApplication.TransientGeometry.CreatePoint2d(0, 0)

                If ViewPosition.X > m_MouseStartPt.X And ViewPosition.Y > m_MouseStartPt.Y Then
                    oCornerPt = m_MouseStartPt
                ElseIf ViewPosition.X > m_MouseStartPt.X And ViewPosition.Y < m_MouseStartPt.Y Then
                    oCornerPt.X = m_MouseStartPt.X
                    oCornerPt.Y = ViewPosition.Y
                ElseIf ViewPosition.X < m_MouseStartPt.X And ViewPosition.Y > m_MouseStartPt.Y Then
                    oCornerPt.X = ViewPosition.X
                    oCornerPt.Y = m_MouseStartPt.Y
                Else
                    oCornerPt = ViewPosition
                End If

                oCornerPt.X = View.Left + oCornerPt.X
                oCornerPt.Y = View.Top + oCornerPt.Y

                Dim bmp As Bitmap = New Bitmap(oSize.Width, oSize.Height, PixelFormat.Format32bppArgb)
                Dim gfx As Graphics = Graphics.FromImage(bmp)
                gfx.CopyFromScreen(oCornerPt.X, oCornerPt.Y, 0, 0, oSize, CopyPixelOperation.SourceCopy)
                System.Windows.Forms.Clipboard.SetImage(bmp)

                Dim ofileDlg As System.Windows.Forms.SaveFileDialog = New System.Windows.Forms.SaveFileDialog
                ofileDlg.Filter = " files" + "(*." + "jpg" + ")|*." + "jpg" + "|All files (*.*)|*.*"

                If ofileDlg.ShowDialog() = DialogResult.OK Then
                    bmp.Save(ofileDlg.FileName)
                End If

            End If

        End Sub

        Private Sub m_InteractionEvents_OnTerminate() Handles m_InteractionEvents.OnTerminate
            m_InteractionEvents.InteractionGraphics.PreviewClientGraphics.Delete()
            m_flagMouseDown = False
            m_InteractionEvents.Stop()
            m_MouseEvents = Nothing
            m_InteractionEvents = Nothing
        End Sub

    End Class

End Namespace

